#ifndef __ALLOCATION_H__
#define __ALLOCATION_H__

#include "addr_range.h"

#define ALLOCATION_OWN 0

enum allocation_flag {
  ALLOCATION_ALLOC,
  ALLOCATION_PREALLOC
};

typedef struct allocation_ allocation;

struct allocation_ {

  enum allocation_flag flag;
  addr_range *a_range;
  unsigned int s_time; /* start time */
  unsigned long owner; 
  unsigned long (* first_addr)(allocation *alloc);
  unsigned long (* last_addr)(allocation *alloc);
  unsigned long (* owner_addr)(allocation *alloc);  
  int (* overlap)(allocation *alloc, allocation *check);
  unsigned int (*end_time)(allocation *alloc);
  unsigned int (*start_time)(allocation *alloc);
  addr_range *(* range)(allocation *alloc);
  int (* is_prealloc)(allocation *alloc);
  void (* delete)(allocation **a);
  void (*debug_print)(allocation *a);
  
};


allocation *allocation_new(enum allocation_flag flag, addr_range *range,
			   unsigned int start_time, unsigned long owner);

#endif
