#ifndef __DEFENDER_H__
#define __DEFENDER_H__

#include "net.h"
#include "net_socket.h"
#include "tim.h"
#include "cfg.h"
#include "allocation.h"
#include "aap.h"
#include "aap_aiu.h"

typedef struct defender_ defender;

struct defender_ {

    net *n;
    net_socket *ns;
    tim *t;
    cfg *cfg;
    aap *aap;

    allocation *alloc;
    aap_aiu *aiu;

    int rseq;
    unsigned long sender;

    list *addr_list;
  
    tim_id_t defense_timer;
    unsigned int last_interval;

    void (* double_interval)(defender *def);
    void (* defend)(defender *def);
    void (* cancel)(defender *def);
    void (* delete)(defender **def);
    int (* overlap)(defender *def, addr_range *ar);
    int (* match)(defender *def, int rseq, unsigned long sender);  
    addr_range *(* range)(defender *def);
};

defender *defender_new(aap *aap, allocation *alloc, int rseq, unsigned long sender);

#endif
